/*
# Date:        2015-11-19
# Author:      simonzhang
# Web:         www.simonzhang.net
# Email:       simon-zzm@163.com
# -------------------------------
*/

package main

import (
        "strconv"
        "runtime"
)

var all int = 1E7 //1E7 = 10^7 = python 10**7

func check(num int) bool{
    status := true
    str:=strconv.Itoa(num)
    var str_len int = len(str)
    var a int=str_len-1
    LOOP:
    for b:=0; b<str_len ; b++{
        if str[a] != str[b]{
            status = false
            break LOOP
        }
        a--
    }
    return status
}

func start(re chan bool){
    for i:=1; i<=all ; i++{
        if  check(i){
            if check(i*i){
                print(i, " ", i*i,"\n")
            }
        }
    }
    re <- true
}

func main(){
  var loopnum int = runtime.NumCPU()
  runtime.GOMAXPROCS(loopnum)
  re:=make(chan bool, loopnum)
  for j:=1; j<=loopnum  ;j++{
      go  start(re)
  }

  sum := 0
  for {
        value := <- re
        if value{
            sum ++
        }
        if sum>=loopnum{
            break
        }
  } 
}
